Ragequit = LibStub("AceAddon-3.0"):NewAddon("Ragequit","AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
local MinimapButton = LibStub("LibDBIcon-1.0")
local AceGUI = LibStub("AceGUI-3.0")

-- local HBD = LibStub("HereBeDragons-2.0")
-- local Pins = LibStub("HereBeDragons-Pins-2.0")

local defaults = {
    factionrealm = {
        minimapButton = { 
            hide = false 
        },
        history = {

        }
    },
    char = {

    }
}

local debugMode = false
local officer = false
local ragequitInited = false
isOfficerLoaded = false

local OriginalSetHyperlink = ItemRefTooltip.SetHyperlink
function ItemRefTooltip:SetHyperlink(link, ...)
    if (link and link:sub(0, 13) == "ragequit:loot") then
        return;
    end
    return OriginalSetHyperlink(self, link, ...);
end


local function CheckForWonLink(self, event, msg, author, ...)
    local newMsg = "";
    local remaining = msg;
    local done;
    repeat
        local start, finish, loot = remaining:find("%[RLOOT:([^%s]+)]");
        if(loot) then
          loot = loot:gsub("|c[Ff][Ff]......", ""):gsub("|r", "");
          newMsg = newMsg..remaining:sub(1, start-1);
          newMsg = newMsg.."|Hragequit:loot|h|cFFe5cc80[RLOOT:"..loot.."]|h|r";
          remaining = remaining:sub(finish + 1);
          newMsg = newMsg .. remaining
        else
          done = true;
        end
    until(done)
    if newMsg ~= "" then
        return false, newMsg, author, ...
    end
end

hooksecurefunc("ChatFrame_OnHyperlinkShow", function(...)
    local chatFrame, link, text, button = ...;

    if(link == "ragequit:loot") then
        local _, _, loot = text:find("%[([^%s]+)]");
        if(loot) then
            local dialog = StaticPopup_Show("RQCOPY")
            local editBox = dialog.editBox
            editBox:SetText(loot)
            editBox:HighlightText()
            editBox:SetFocus()
        end
    end
end)

ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", CheckForWonLink)

function Ragequit:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("RQDB2", defaults)

    Ragequit:RegisterChatCommand('export', 'HandleExportCommand')

    local realm = GetRealmName()

    if(realm == "Stonespine") then
        Ragequit:RegisterEvent("TRADE_SKILL_SHOW")
        Ragequit:RegisterEvent("PLAYER_ENTERING_WORLD")
        Ragequit:RegisterEvent("TRADE_SKILL_UPDATE")
        Ragequit:RegisterEvent("CRAFT_UPDATE")
    end

    Ragequit:RegisterEvent("PLAYER_GUILD_UPDATE")
    Ragequit:RegisterEvent("GUILD_ROSTER_UPDATE")
    if debugMode then
        Ragequit:RegisterEvent("CHAT_MSG_PARTY_LEADER")
        Ragequit:RegisterEvent("CHAT_MSG_PARTY") 
    else
        Ragequit:RegisterEvent("CHAT_MSG_RAID_LEADER")
        Ragequit:RegisterEvent("CHAT_MSG_RAID") 
    end
    -- Ragequit:RegisterEvent("CHAT_MSG_SYSTEM") 
    Ragequit:RegisterEvent("UNIT_INVENTORY_CHANGED")
    Ragequit:RegisterEvent("GROUP_ROSTER_UPDATE")

    -- Ragequit:PlayerPosition(f);

    -- C_Timer.NewTicker(60, function()
        -- Ragequit:PlayerPosition(f)
    -- end)

    Ragequit:initBuffButton()
    Ragequit:InitMinimapIcon()

    C_ChatInfo.RegisterAddonMessagePrefix("WF_STATUS")
end

function Ragequit:InitMinimapIcon()
    MinimapButton:Register("Ragequit", LibStub("LibDataBroker-1.1"):NewDataObject("Ragequit",
    {
        type = "data source",
        text = "Ragequit",
        icon = "Interface\\Icons\\Spell_magic_polymorphchicken",
        OnClick = function(self, button)
            if (button == "LeftButton" and IsControlKeyDown()) then
                Ragequit:CheckBuffs()
            elseif (button == "LeftButton") then
                Ragequit:AnnounceBuffs()
            elseif (button == "RightButton" and IsShiftKeyDown()) then
                Ragequit:ClearCrafting()
            elseif (button == "RightButton") then
                Ragequit:ExportCrafting()
            end
        end,
        OnTooltipShow = function(tooltip)
            tooltip:AddLine("Ragequit");
            tooltip:AddLine("|cFFCFCFCFLeft Click: |rCheck Buffs");
            tooltip:AddLine("|cFFCFCFCFLeft Click + Ctrl: |rCheck Worldbuffs");
            tooltip:AddLine("|cFFCFCFCFRight Click: |rExport Crafting");
            tooltip:AddLine("|cFFCFCFCFRight Click + Shift: |rClear Crafting Cache");
            tooltip:AddLine("Toggle button with /ragequit minimap");
        end
    }), self.db.factionrealm.minimapButton);
end

function Ragequit:PlayerPosition(f)
    local x, y, instanceID = HBD:GetPlayerWorldPosition()
    local playerName = UnitName("player")
    local className, _, _ = UnitClass("player")

    print(x, y, instanceID)

    Pins:AddMinimapIconWorld("ragequitPlayer" .. playerName, playerIcon, instanceID, x, y, true)
end

function Ragequit:isDebugMode()
    return debugMode
end

function Ragequit:isOfficer()
    return officer
end

function Ragequit:HandleExportCommand(input)
	Ragequit:ExportCrafting()
end

function Ragequit:HandleRagequitCommand(input)
    if input ~= nil then
        if input == "wb" then
            Ragequit:CheckBuffs()
        end
        if input == "minimap" then
            if self.db.factionrealm.minimapButton.hide == true then
                self.db.factionrealm.minimapButton.hide = false
                MinimapButton:Show("Ragequit")
                DEFAULT_CHAT_FRAME:AddMessage("Ragequit: Minimap button toggled on")
            else
                self.db.factionrealm.minimapButton.hide = true
                MinimapButton:Hide("Ragequit")
                DEFAULT_CHAT_FRAME:AddMessage("Ragequit: Minimap button toggled off")
            end
        end
    else 
        DEFAULT_CHAT_FRAME:AddMessage("/ragequit minimap")
        DEFAULT_CHAT_FRAME:AddMessage("/ragequit wb")
    end
end

function Ragequit:ExportCrafting()
    local characters = {}
    local characterNames = {}
    local realm = GetRealmName()

    if realm == "Stonespine" then
        for character, data in pairs(RQDB2.char) do
            local nameFormatted = stripRealm(character)
            if not (tableEmpty(data["tradeskills"])) then
                table.insert(characterNames, nameFormatted)
                table.insert(characters, { name=nameFormatted, tradeskills=data["tradeskills"] })
            end
        end
        
        -- DEFAULT_CHAT_FRAME:AddMessage(string.format("Exporting crafting for %s", table.concat(characterNames, ", ")))
        Ragequit:CopyFrame("Crafting Data", "CTRL + C then paste back into ragequit.cloud/crafting", Ragequit:Encode(encode(characters)))
    else
        DEFAULT_CHAT_FRAME:AddMessage("export only works on Stonespine")
    end
end

function Ragequit:CopyFrame(title, description, text)
    local f = AceGUI:Create("Frame")
    f:SetTitle("Ragequit CopyPaster")
    f:SetStatusText(description)
    f:SetCallback("OnClose", function(widget)
        AceGUI:Release(widget) 
    end)
    f:SetLayout("Flow")

    local copyTextBox = AceGUI:Create("CopyPasterBox")
    copyTextBox:SetFullHeight(true)
    copyTextBox:SetFullWidth(true)
    copyTextBox:SetLabel(title)
    copyTextBox:SetCallback("OnTextChanged", function(widget, newText)
        copyTextBox:SetText(text)
    end)
    copyTextBox:SetText(text)
    copyTextBox:DisableButton(true)
    copyTextBox:HighlightText()
    copyTextBox:SetFocus()
    f:AddChild(copyTextBox)
end

function Ragequit:ClearCrafting()
    self.db.char["tradeskills"] = {}

    local name = stripRealm(UnitName("player"))

    DEFAULT_CHAT_FRAME:AddMessage(string.format("Crafting reset for %s", name))
    DEFAULT_CHAT_FRAME:AddMessage("Open Tradeskills again to update cache")
end

function Ragequit:GetPlayerInfo()
    local realm = GetRealmName()
    local player = UnitName("player")
    return realm, player
end

function Ragequit:Encode(data)
    local Base64Chars='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

    return ((data:gsub('.', function(x) 
        local r,Base64Chars='',x:byte()
        for i=8,1,-1 do r=r..(Base64Chars%2^i-Base64Chars%2^(i-1)>0 and '1' or '0') end
        return r;
    end)..'0000'):gsub('%d%d%d?%d?%d?%d?', function(x)
        if (#x < 6) then return '' end
        local c=0
        for i=1,6 do c=c+(x:sub(i,i)=='1' and 2^(6-i) or 0) end
        return Base64Chars:sub(c+1,c+1)
    end)..({ '', '==', '=' })[#data%3+1])
end

function Ragequit:Decode(data)
    local Base64Chars='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

    data = string.gsub(data, '[^'..Base64Chars..'=]', '')
    return (data:gsub('.', function(x)
        if (x == '=') then return '' end
        local r,f='',(Base64Chars:find(x)-1)
        for i=6,1,-1 do r=r..(f%2^i-f%2^(i-1)>0 and '1' or '0') end
        return r;
    end):gsub('%d%d%d?%d?%d?%d?%d?%d?', function(x)
        if (#x ~= 8) then return '' end
        local c=0
        for i=1,8 do c=c+(x:sub(i,i)=='1' and 2^(8-i) or 0) end
            return string.char(c)
    end))
end

function Ragequit:InitOfficer(guildRankName)
    if has_value(officerGuildRanks, guildRankName) then

        isOfficer = true
        if isOfficerLoaded == false then
            
            if Ragequit:isDebugMode() then print("Ragequit:InitOfficer()") end

            isOfficerLoaded = true

            Ragequit:Hook("ContainerFrameItemButton_OnModifiedClick", true)

            Ragequit:RegisterChatCommand('auction', 'HandleAuctionCommand')
            Ragequit:RegisterChatCommand('offspec', 'HandleAuctionOSCommand')
            Ragequit:RegisterChatCommand('ragequit', 'HandleRagequitCommand')

            local RQRaidButtonInvite = CreateFrame("Button", "rageButtonInvite", RaidFrame, "UIPanelButtonTemplate")
            RQRaidButtonInvite:SetSize(80 ,30)
            RQRaidButtonInvite:SetFrameLevel(1)
            RQRaidButtonInvite:SetText("Invite")
            RQRaidButtonInvite:SetPoint("TOPRIGHT", 85, -97)
            RQRaidButtonInvite:SetScript("OnClick", function()
                StaticPopup_Show("RQINVITE")
            end)

            local RQRaidButtonAttending = CreateFrame("Button", "rageButtonAttending", RaidFrame, "UIPanelButtonTemplate")
            RQRaidButtonAttending:SetSize(80 ,30)
            RQRaidButtonAttending:SetFrameLevel(1)
            RQRaidButtonAttending:SetText("Export")
            RQRaidButtonAttending:SetPoint("TOPRIGHT", 85, -62)
            RQRaidButtonAttending:SetScript("OnClick", function()
                Ragequit:RaidMembers()
            end)
            RQRaidButtonAttending:SetScript("OnUpdate", function()
                if IsInRaid() then
                    RQRaidButtonAttending:Enable();
                else
                    RQRaidButtonAttending:Disable();
                end
            end)

            local RQButtonRoster = CreateFrame("Button", "rageButtonRoster", GuildFrame, "UIPanelButtonTemplate")
            RQButtonRoster:SetSize(80 ,30)
            RQButtonRoster:SetFrameLevel(1)
            RQButtonRoster:SetText("Synkroniser")
            RQButtonRoster:SetPoint("TOPRIGHT", 0, 30)
            RQButtonRoster:SetScript("OnClick", function()
                Ragequit:GuildMembers()
            end)
        end
    end
end

function Ragequit:TRADE_SKILL_SHOW()
    local realm, player = Ragequit:GetPlayerInfo()

    if (self.db.char["tradeskills"] == nil) then
        self.db.char["tradeskills"] = {}
    end
end

function Ragequit:UNIT_INVENTORY_CHANGED()
    Ragequit:TransmitWindfuryStatus()
end

function Ragequit:PLAYER_GUILD_UPDATE()
    local guildName, guildRankName, _ = GetGuildInfo("player")

    if(guildName == "Ragequit") then
        Ragequit:InitOfficer(guildRankName)
    end
end

function Ragequit:GUILD_ROSTER_UPDATE()
    local guildName, guildRankName, _ = GetGuildInfo("player")

    if(guildName == "Ragequit") then
        Ragequit:InitOfficer(guildRankName)
    end
end

function Ragequit:PLAYER_ENTERING_WORLD()
    if (ragequitInited == false) then
        ragequitInited = true;

        Ragequit:initTooltip()
    end
end

function Ragequit:TRADE_SKILL_UPDATE()

    if(self.db.char["tradeskills"] == nil) then
        self.db.char["tradeskills"] = {}
    end

    local totalRecipes = GetNumTradeSkills()
    local index = GetFirstTradeSkill()

    if (index == 0) then return end

    local tradeskillName, currentLevel, maxLevel = GetTradeSkillLine()
    local data = {}
    data["current"] = currentLevel
    data["max"] = maxLevel
    data["recipes"] = {}

    for i = 1, GetNumTradeSkills() do
        local name, cType, _, _, _, _ = GetTradeSkillInfo(i)
        if (name and (cType ~= "header")) then
        	local itemLink = GetTradeSkillItemLink(i)
            table.insert(data["recipes"], {name = name, link = itemLink})
        end
    end

    if self.db.char["tradeskills"][tradeskillName] ~= nil then
        if Ragequit:isCacheOlder(self.db.char["tradeskills"][tradeskillName].recipes, data.recipes) then
            DEFAULT_CHAT_FRAME:AddMessage("Found new recipes! upload to ragequit.cloud/crafting") 
        end
    end

    self.db.char["tradeskills"][tradeskillName] = data
end

function Ragequit:CRAFT_UPDATE()
    local craftName = GetCraftName()
    if (craftName == 'Enchanting') then

        if (self.db.char["tradeskills"] == nil) then
            self.db.char["tradeskills"] = {}
        end

        local totalRecipes = GetNumCrafts()

        if (totalRecipes == 0) then return end

        local name, currentLevel, maxLevel = GetCraftDisplaySkillLine()
        local data = {}
        data["current"] = currentLevel
        data["max"] = maxLevel
        data["recipes"] = {}

        for i = 1, totalRecipes do
            local name, _, cType, _, _, _, _ = GetCraftInfo(i);
            if (name and (cType ~= "header")) then
                local itemLink = GetCraftItemLink(i);
                table.insert(data["recipes"], {name = name, link = itemLink})
            end
        end

        if self.db.char.tradeskills.Enchanting ~= nil then
            if Ragequit:isCacheOlder(self.db.char.tradeskills.Enchanting.recipes, data.recipes) then
                DEFAULT_CHAT_FRAME:AddMessage("Found new recipes! upload to ragequit.cloud/crafting") 
            end
        end

        self.db.char["tradeskills"]["Enchanting"] = data
    end
end

function Ragequit:isCacheOlder(oldRecipes, newRecipes)
    if oldRecipes == nil then
        return false
    end

    if #(newRecipes) > #(oldRecipes) then 
        return true 
    end

    return false
end