-- https://github.com/Alumian/CEPGP-Retail/ all credits.

local dkp_color_0 = 0.90588235294118
local dkp_color_1 = 0.29803921568627
local dkp_color_2 = 0.23529411764706
		
local DKP_tokens = {
	Heads = {
		["Trinket"] = {
			[18423] = 74,	-- of Onyxia (Alliance) -- Can also be a neck and ring
			[18422] = 74,	-- of Onyxia (Horde) -- Same deal
			[19802] = 68,	-- Heart of Hakkar
			[22520] = 90	-- Phylactery of Kel'Thuzad
		},
		["Neck"] = {
			[21220] = 70,	-- of Ossirian the Unscarred
			[21221] = 88 	-- Eye of C'Thun -- Can also be a cloak or ring
		},
		["Holdable"] = {
			[19003] = 83, 	-- of Nefarian (Alliance) -- Can also be neck and ring
			[19002] = 83	-- of Nefarian (Horde) -- Same deal
		}
	},

	ZG = {
		["Wrist"] = {
			[19717] = 61,	-- Armsplint
			[19716] = 61,	-- Bindings
			[19718] = 61,	-- Stanchion
		},
		["Waist"] = {
			[19719] = 61,	-- Girdle
			[19720] = 61	-- Sash
		},
		["Chest"] = {
			[19724] = 65,	-- Aegis
			[19723] = 65,	-- Kossack
			[19722] = 65	-- Tabard
		},
		["Shoulder"] = {
			[19721] = 68	-- Shawl
		}
	},

	AQ = {
		["Cloak"] = {
			[20885] = 67,	-- Martial Drake
			[20889] = 67	-- Regal Drape
		},
		["Finger"] = {
			[20888] = 65,	-- Ceremonial Ring
			[20884] = 65	-- Magisterial Ring
		},
		["Weaponoffhand"] = {
			[20886] = 70,	-- Spiked Hilt -- Exceptions apply - Paladin / Shaman weapon are main hand
			[21232] = 79,	-- Imperial Qiraji Armaments -- Can also be a ranged weapon or shield
		},
		["Weaponmainhand"] = {
			[20890] = 70	-- Ornate Hilt
		},
		["TwoHweapon"] = {
			[21237] = 79	-- Imperial Qiraji Regalia -- Can also be a one-handed weapon
		},
		["Feet"] = {
			[20928] = 78,	-- Qiraji Bindings of Command -- Can also be shoulders
			[20932] = 78	-- Qiraji Bindings of Dominance -- same deal
		},
		["Chest"] = {
			[20933] = 88,	-- Husk of the Old God
			[20929] = 88	-- Carapace of the Old God
		},
		["Legs"] = {
			[20927] = 81,	-- Ouro's Intact Hide
			[20931] = 81	-- Skin of the Great Sandworm
		}
	},

	T3 = {
		["Shoulder"] = {
			[22368] = 86,	-- Shoulderpads
			[22354] = 86,	-- Pauldrons
			[22361] = 86	-- Spaulders
		},
		["Feet"] = {
			[22372] = 86,	-- Sandals
			[22365] = 86,	-- Boots
			[22358] = 86	-- Sabatons
		},
		["Wrist"] = {
			[22369] = 88,	-- Bindings
			[22362] = 88,	-- Wristguards
			[22355] = 88	-- Bracers
		},
		["Hand"] = {
			[22357] = 88,	-- Gauntlets
			[22364] = 88,	-- Handguards
			[22371] = 88,	-- Gloves
		},
		["Waist"] = {
			[22363] = 88,	-- Girdle
			[22370] = 88,	-- Belt
			[22356] = 88	-- Waistguard
		},
		["Legs"] = {
			[22359] = 88,	-- Legguards
			[22352] = 88,	-- Legplates
			[22366] = 88	-- Leggings
		},
		["Head"] = {
			[22367] = 88,	-- Circlet
			[22360] = 88,	-- Headpiece
			[22353] = 88	-- Helmet
		},
		["Chest"] = {
			[22350] = 92,	-- Tunic
			[22351] = 92,	-- Robe
			[22349] = 92	-- Breastplate
		}
	}
}

local COEF = 4.83;
local MOD = 0.5;
local MOD_COEF = 2;
local OVERRIDE_INDEX = {
	[18563] = 160, -- Bindings of the Windseeker (Left side)
	[18564] = 160, -- Bindings of the Windseeker (Right side)
	[17204] = 250, -- Eye of Sulfuras
	[17182] = 250 -- Sulfuras, Hand of Ragnaros
};
local SLOTWEIGHTS = {
	["2HWEAPON"] = 5,
	["WEAPONMAINHAND"] = 3,
	["WEAPON"] = 3,
	["WEAPONOFFHAND"] = 3,
	["HOLDABLE"] = 0.5,
	["SHIELD"] = 3,
	["RANGED"] = 3,
	["RANGEDRIGHT"] = 0.5,
	["THROWN"] = 0.5,
	["RELIC"] = 0.5,
	["HEAD"] = 1,
	["NECK"] = 0.5,
	["SHOULDER"] = 0.75,
	["CLOAK"] = 0.5,
	["CHEST"] = 1,
	["ROBE"] = 1,
	["WRIST"] = 0.5,
	["HAND"] = 0.75,
	["WAIST"] = 0.75,
	["LEGS"] = 1,
	["FEET"] = 0.75,
	["FINGER"] = 3,
	["TRINKET"] = 3,
	["EXCEPTION"] = 1
}

function DKP_calc(link, quantity)

	local name, rarity, ilvl, itemType, subType, slot, classID, subClassID, id;

	if link then
		name, _, rarity, ilvl, itemType, subType, _, _, slot, _, _, classID, subClassID = GetItemInfo(link);
		_, _, _, _, id = string.find(link, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+)")
	else
		return 0;
	end

	if not ilvl then ilvl = 0; end
	for k, v in pairs(OVERRIDE_INDEX) do
		if k == tonumber(id) then
			return v;
		end
	end
	for _, k in pairs(DKP_tokens) do
		for slotName, v in pairs(k) do
			if k[slotName][tonumber(id)] then
				slot = "INVTYPE_" .. string.upper(slotName);
				ilvl = k[slotName][tonumber(id)];
				break;
			end
		end
	end
	if slot == "" or slot == nil then
		slot = "INVTYPE_EXCEPTION";
	end
	
	if slot == "INVTYPE_ROBE" then slot = "INVTYPE_CHEST"; end
	if slot == "INVTYPE_WEAPON" then slot = "INVTYPE_WEAPONOFFHAND"; end
	slot = strsub(slot,strfind(slot,"INVTYPE_")+8,string.len(slot));
	slot = SLOTWEIGHTS[slot];
	if ilvl and rarity and slot then
		return math.floor((((COEF * (MOD_COEF^((ilvl/26) + (rarity-4))) * slot)*MOD)*quantity));
	else
		return 0;
	end
end

function DKP_calc_min(link)
	local dkp = DKP_calc(link, 1) 

	if dkp < 10 then
		return 10
	end

	return dkp
end

function DKP_calc_min_os(link)
	local dkp = DKP_calc(link, 1) 

	dkp = math.ceil(dkp / 2)

	if dkp < 10 then
		return 10
	end

	return dkp
end

local function DKPTooltip(tooltip)
	if tooltip:GetItem() ~= nil then
		local _, itemlink = tooltip:GetItem();

		if itemlink ~= nil then
			local _, _, quality, _, _, _, _, _, _, _, _, _, _, bindType, _, _, _ = GetItemInfo(itemlink)

			if (quality ~= nil) and (quality > 2) then
				if bindType == 1 then
					local dkp = DKP_calc(itemlink, 1)

					if dkp > 0 then

						if dkp < 10 then
							dkp = 10
						end

						local osdkp = math.ceil(dkp / 2)

						if osdkp < 10 then
							osdkp = 10
						end

						if dkp == 10 then
							tooltip:AddLine(string.format("DKP: %s", dkp), dkp_color_0, dkp_color_1, dkp_color_2, true)
						else
							tooltip:AddLine(string.format("DKP: %s (%s OS)", dkp, osdkp), dkp_color_0, dkp_color_1, dkp_color_2, true)
						end
					end
				else
					tooltip:AddLine("DKP: Roll", dkp_color_0, dkp_color_1, dkp_color_2, true)
				end
			end
		end
	end
end

function Ragequit:initTooltip()
	GameTooltip:HookScript("OnTooltipSetItem", DKPTooltip)
end

