function Ragequit:initBuffButton()
    local RQRaidButtonBuffs = CreateFrame("Button", "rageButtonBuffs", RaidFrame, "UIPanelButtonTemplate")
    RQRaidButtonBuffs:SetSize(80 ,30)
    RQRaidButtonBuffs:SetText("Buffs")
    RQRaidButtonBuffs:SetFrameLevel(1)
    RQRaidButtonBuffs:SetPoint("TOPRIGHT", 85, -27)
    RQRaidButtonBuffs:SetScript("OnClick", function()
        Ragequit:AnnounceBuffs() 
    end)
    RQRaidButtonBuffs:SetScript("OnEnter", function()
        GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
        GameTooltip:SetPoint("BOTTOMRIGHT", RQRaidButtonBuffs, "TOPLEFT");
        GameTooltip:ClearLines();
        GameTooltip:SetText(Ragequit:CheckRaidBuffs());
    end)
    RQRaidButtonBuffs:SetScript("OnLeave", function()
        GameTooltip:Hide();
    end)
    RQRaidButtonBuffs:SetScript("OnUpdate", function()
        if IsInRaid() then
            RQRaidButtonBuffs:Enable();
        else
            RQRaidButtonBuffs:Disable();
        end
    end)
end

function Ragequit:AnnounceBuffs() 
    if IsInRaid() then
        local output = Ragequit:CheckRaidBuffs()
        local text = splitString(output, "\n")

        for i = 1, #text do
            SendChatMessage(text[i], "RAID");
        end
    else
        DEFAULT_CHAT_FRAME:AddMessage("Not in Raid")
    end
end

local function manaClass(raidbuffs, players, name)
    -- motw / gotw    
    if (raidbuffs["9885"] == nil) and (raidbuffs["21850"] == nil) then
        if not players["MotW"] then players["MotW"] = {} end
        table.insert(players["MotW"], name)
    end

    -- Prayer of spirit /
    if (raidbuffs["27681"] == nil) and (raidbuffs["27841"] == nil) then
        if not players["Spirit"] then players["Spirit"] = {} end
        table.insert(players["Spirit"], name)
    end

    -- Prayer of fortitude /
    if (raidbuffs["21564"] == nil) and (raidbuffs["10938"] == nil) then
        if not players["Fortitude"] then players["Fortitude"] = {} end
        table.insert(players["Fortitude"], name)
    end

    -- Arcane Intellect / Arcane Brilliance
    if (raidbuffs["10157"] == nil) and (raidbuffs["23028"] == nil) then
        if not players["Intellect"] then players["Intellect"] = {} end
        table.insert(players["Intellect"], name)
    end
end

local function notManaClass(raidbuffs, players, name)
    -- motw / gotw    
    if (raidbuffs["9885"] == nil) and (raidbuffs["21850"] == nil) then
        if not players["MotW"] then players["MotW"] = {} end
        table.insert(players["MotW"], name)
    end

    -- Prayer of fortitude /
    if (raidbuffs["21564"] == nil) and (raidbuffs["10938"] == nil) then
        if not players["Fortitude"] then players["Fortitude"] = {} end
        table.insert(players["Fortitude"], name)
    end
end

function Ragequit:MergeBuffNeeded(tbl, output, buff)
    if tbl ~= nil then
        local count = tablelength(tbl)

        if tablelength(tbl) < 8 then
            return output .. buff .. ": " .. table.concat(tbl, ", ") .. "\n"
        else
            return output .. string.format("%s: %s missing\n", buff, count)
        end
    end

    return output
end

function Ragequit:CheckRaidBuffs()
    local players = {}

    for i = 1, 40 do
        name, _, group = GetRaidRosterInfo(i)
        if name then
            Ragequit:CheckUnitRaidBuffs(players, "raid" .. i, name)
        end
    end

    local output = "" 

    if next(players) == nil then
        output = output .. "Buffed and ready! (MotW, Spirit, Fortitude and Intellect)" .. "\n"
    else
        output = output .. "Missing Raidbuffs:" .. "\n"

        output = Ragequit:MergeBuffNeeded(players["MotW"], output, "MotW")
        output = Ragequit:MergeBuffNeeded(players["Spirit"], output, "Spirit")
        output = Ragequit:MergeBuffNeeded(players["Fortitude"], output, "Fortitude")
        output = Ragequit:MergeBuffNeeded(players["Intellect"], output, "Intellect")
    end

    return output
end

function Ragequit:CheckUnitRaidBuffs(players, unit, name)
    if not UnitIsConnected(unit) or UnitIsDeadOrGhost(unit) then return end

    local localizedClass, englishClass = UnitClass(unit);
    local raidbuffs = {}

    for i = 1, 40 do
        local buffName, _, _, _, _, _, _, _, _, spellId = UnitBuff(unit, i)
        if spellId then 
            spellId = tostring(spellId)
            raidbuffs[spellId] = buffName
        end
    end

    if englishClass == "WARRIOR" then
        notManaClass(raidbuffs, players, name)
    elseif englishClass == "SHAMAN" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "PRIEST" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "MAGE" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "DRUID" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "HUNTER" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "WARLOCK" then
        manaClass(raidbuffs, players, name)
    elseif englishClass == "ROGUE" then
        notManaClass(raidbuffs, players, name)
    end
end